import 'dart:convert';

import 'package:shared_preferences/shared_preferences.dart';
import 'package:wowit/methods.dart';

class CacheData {
  static SharedPreferences? _preferences;

  static void cache(String key, Map<String, List<Map<String, Object?>?>?> data,
      {Map<String, Object?>? jParam}) async {
    _preferences = _preferences ?? await SharedPreferences.getInstance();

    jParam?.forEach((key, value) {
      if (key == 'PageNumber' || key == '@PageNumber') {
        int page = Methods.getInt(jParam, key);
        if (page > 1) {
          return;
        }
      }
    });

    if (_preferences!.containsKey(key)) {
      bool isReCache = false;
      String? sData = _preferences!.getString(key);
      if (sData != null) {
        var mapData = _stringToMap(sData);
        data.forEach((keyMap, value) {
          var listData = Methods.getList(data, keyMap);
          if (mapData.containsKey(keyMap)) {
            var listTempDdata = Methods.getList(mapData, keyMap);
            if (listTempDdata.length > listData.length) {
              isReCache = true;
              return;
            }
          }
        });
      }
      if (!isReCache) {
        return;
      }
      await _preferences!.remove(key);
    }

    await _preferences!.setString(key, json.encode(data));
  }

  static Future<Map<String, List<Map<String, Object?>?>?>> getData(String key,
      {Map<String, Object?>? jParam}) async {
    _preferences = _preferences ?? await SharedPreferences.getInstance();

    bool checkData = false;

    jParam?.forEach((key, value) {
      if (key == 'PageNumber' || key == '@PageNumber') {
        int page = Methods.getInt(jParam, key);
        if (page > 1) {
          checkData = true;
          return;
        }
      }
    });

    if (checkData) {
      return {};
    }

    if (_preferences!.containsKey(key)) {
      String? sData = _preferences!.getString(key);
      if (sData != null) {
        return _stringToMap(sData);
      }
    }
    return {};
  }

  static Map<String, List<Map<String, Object?>?>?> _stringToMap(String sData) {
    Map<String, List<Map<String, Object?>?>?> retVal = {};
    Map<String, dynamic> jsonData = json.decode(sData);

    jsonData.forEach((key, value) {
      List<dynamic> table = value;
      List<Map<String, Object>> rsTable = [];
      for (int i = 0; i < table.length; i++) {
        rsTable.add(Map<String, Object>.from(table[i]));
      }
      retVal[key] = rsTable;
    });
    return retVal;
  }
}
