import 'package:get/get.dart';
import 'package:wowit/interfaces/mixins/handle_exception_mixin.dart';
import 'package:wowit/interfaces/mixins/online_status_mixin.dart';

abstract class BaseController extends GetxController
    with OnlineStatusMixin, HandleExceptionMixin {
  final Map<String, Object?> params = {};

  final Map<String, List<Map<String, Object?>?>?> _data = {};

  final Map<String, String> messageIdBackUp = {};

  Future<Map<String, List<Map<String, Object?>?>?>?>? loadData();

  Map<String, List<Map<String, Object?>?>?> getData() {
    return _data;
  }

  void setData(Map<String, List<Map<String, Object?>?>?> data) {
    _data.clear();
    _data.addAll(data);
  }

  void clearData() {
    params.clear();
    _data.clear();
  }

  @override
  void updateOnlineStatus() {
    update();
  }

  @override
  void onInit() {
    super.onInit();
    initConnectivity();
  }

  @override
  void onClose() {
    super.onClose();
    initConnectivity();
  }

  void reload() {
    clearData();
    refresh();
  }
}
