import 'package:wowit/firebase_service.dart';
import 'package:wowit/interfaces/enums/common_enum.dart';
import 'package:wowit/interfaces/interfaces.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/sql_service.dart';
import 'package:http/http.dart' as http;
import 'dart:convert';

class AuthUtil {
  AuthUtil._();

  static Future requestPermissionFireBaseMessage(String notifyTokenId) async {
    if (await FirebaseService.initializeFirebaseMessaging()) {
      await FirebaseService.initNotifyToken(notifyTokenId);
    }
  }

  static Future updateAccountStatus({required AccountStatus status}) async {
    Map<String, Object> params = {
      '@statusId': status.code,
    };
    await SQLService.execute('sp_UpdateAccountStatus', params: params);
  }

  static Future<ServerStatus> checkSever() async {
    try {
      var response = await http.post(
        Methods.getURI('/Data/CheckConnectionInfo'),
      );
      var serverStatus = ServerStatus.fromCode(
        Methods.toInt(json.decode(response.body).toString()),
      );
      return serverStatus;
    } catch (e) {
      HandleException.log(e);
      return ServerStatus.unknown;
    }
  }
}
