import 'package:wowit/controllers/base_controller.dart';

mixin SearchMixin on BaseController {
  String keyword = '';

  /// Thêm [keyword] vào [params]
  ///
  /// Ví dụ:
  /// ```dart
  /// @override
  /// Future<Map<String, List<Map<String, Object?>?>?>?>? loadData() async {
  ///   addSearch();
  ///   var data = await SQLService.execute(
  ///     'sp_...',
  ///     params: params,
  ///     formatJson: Parameter.FORMAT_JSON,
  ///   );
  ///   return data;
  /// }
  /// ```
  void addSearch() {
    params['keyword'] = keyword;
  }

  /// áp dụng tìm kiếm => cập nhật dữ liệu => cập nhật giao diện
  void search(String keyword) async {
    if (this.keyword == keyword) return;
    this.keyword = keyword;
    reload();
  }
}
