import 'package:flutter/foundation.dart';
import 'package:wowit/common.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/sql_service.dart';

abstract class UpdateVersionMixin {
  void initCheckUpdate() async {
    var data = await SQLService.execute('sp_Parameter',
        params: {'code': 'VERSION_MOI_NHAT'});
    if (kReleaseMode) {
      _checkVersion(data);
    }
  }

  void _checkVersion(Map<String, List<Map<String, Object?>?>?> data) {
    try {
      List<Map<String, Object?>> lstData =
          Methods.getList(data, 'data_Parameter');
      if (lstData.isNotEmpty) {
        // Parameter.VERSION_MOI_NHAT =
        List<String> lstThongTin =
            Methods.getString(lstData.first, 'value').split(' ');
        if (lstThongTin.isNotEmpty) {
          String? sVersion = (lstThongTin.first.split('.')).last;
          if (sVersion.isNotEmpty) {
            int version = Methods.toInt(sVersion);
            if (version > Common.fVersion && lstThongTin.length >= 2) {
              _dialogUpdateVersion(Methods.toInt(lstThongTin[1]));
            }
          }
        }
      }
    } catch (e) {
      if (kDebugMode) {
        print('$e');
      }
    }
  }

  void _dialogUpdateVersion(int trangThai) {
    switch (trangThai) {
      case CapNhatVersion.capNhat:
        dialogCapNhat();
        break;
      case CapNhatVersion.thongBao:
        dialogThongBaoCapNhat();
        break;
      default:
        break;
    }
  }

  void dialogCapNhat();
  void dialogThongBaoCapNhat();
}
