import 'dart:convert';

import 'package:wowit/methods.dart';
import 'package:wowit/models/base_model.dart';

class Picker extends BaseModel {
  /// old version
  Picker(
    int? parentValue,
    int valueMember,
    String displayMember,
  ) : super(
          {
            'title': displayMember,
            'ID': valueMember,
            'parentId': parentValue,
            'refID': parentValue,
          },
        );

  Picker.data(Map<String, Object?>? data) : super(data ?? {});

  factory Picker.fromJson(String json) {
    Map<String, dynamic> jsonData = jsonDecode(json);
    return Picker.data(jsonData);
  }

  static String toJson(Picker value) {
    String json = jsonEncode(value.data);
    return json;
  }

  @Deprecated('valueMember == ID')
  int get valueMember => Methods.getInt(data, 'ID');

  @Deprecated('displayMember == title')
  String get displayMember => Methods.getString(data, 'title');

  @Deprecated('parentValue == refID')
  int? get parentValue {
    int refId = Methods.getInt(
      data,
      'parentId',
      defaultValue: Methods.getInt(data, 'refID'),
    );
    if (refId <= 0) return null;
    return refId;
  }

  String get title => Methods.getString(data, 'title');

  int? get refID {
    int refId = Methods.getInt(
      data,
      'refID',
      defaultValue: Methods.getInt(data, 'parentId'),
    );
    if (refId <= 0) return null;
    return refId;
  }
}

class RangeValue {
  const RangeValue(
    this.start,
    this.end, {
    this.title = ' ',
  });
  final String title;
  final double start;
  final double? end;
}
