import 'package:flutter/material.dart';
import 'package:wowit/interfaces/mixins/online_status_mixin.dart';
import 'package:wowit/message.dart';

class ConnectivityWidget extends StatefulWidget {
  const ConnectivityWidget({Key? key}) : super(key: key);

  @override
  State<ConnectivityWidget> createState() => _ConnectivityWidgetState();
}

class _ConnectivityWidgetState extends State<ConnectivityWidget>
    with OnlineStatusMixin {
  @override
  void initState() {
    super.initState();
    initConnectivity();
  }

  @override
  void dispose() {
    super.dispose();
    disposeConnectivity();
  }

  @override
  Widget build(BuildContext context) {
    return AnimatedContainer(
      height: isOnline ? 0 : 20,
      duration: const Duration(milliseconds: 300),
      child: Container(
        color: Theme.of(context).primaryColor,
        width: MediaQuery.of(context).size.width,
        child: Center(
          child: Text(
            Message.getMessage('NO_INTERNET_CONNECTION'),
            style: const TextStyle(
              color: Colors.white,
              fontSize: 10,
            ),
          ),
        ),
      ),
    );
  }

  @override
  void updateOnlineStatus() {
    setState(() {});
  }
}
